---
title: Strict equality (===)
slug: Web/JavaScript/Reference/Operators/Strict_equality
tags:
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p>The strict equality operator (<code>===</code>) checks whether its two operands are equal, returning a Boolean result. Unlike the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Equality">equality</a> operator, the strict equality operator always considers operands of different types to be different.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-strict-equality.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">x === y</pre>

<h2 id="Description">Description</h2>

<p>The strict equality operators (<code>===</code> and <code>!==</code>) use the <a class="external external-icon" href="http://www.ecma-international.org/ecma-262/5.1/#sec-11.9.6" rel="noopener">Strict Equality Comparison Algorithm</a> to compare two operands.</p>

<ul>
 <li>If the operands are of different types, return <code>false</code>.</li>
 <li>If both operands are objects, return <code>true</code> only if they refer to the same object.</li>
 <li>If both operands are <code>null</code> or both operands are <code>undefined</code>, return <code>true</code>.</li>
 <li>If either operand is <code>NaN</code>, return <code>false</code>.</li>
 <li>Otherwise, compare the two operand's values:
  <ul>
   <li>Numbers must have the same numeric values. <code>+0</code> and <code>-0</code> are considered to be the same value.</li>
   <li>Strings must have the same characters in the same order.</li>
   <li>Booleans must be both <code>true</code> or both <code>false</code>.</li>
  </ul>
 </li>
</ul>

<p>The most notable difference between this operator and the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Equality">equality</a> (<code>==</code>) operator is that if the operands are of different types, the <code>==</code> operator attempts to convert them to the same type before comparing.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Comparing_operands_of_the_same_type">Comparing operands of the same type</h3>

<pre class="brush: js notranslate">console.log("hello" === "hello");   // true
console.log("hello" === "hola");    // false

console.log(3 === 3);               // true
console.log(3 === 4);               // false

console.log(true === true);         // true
console.log(true === false);        // false

console.log(null === null);         // true</pre>

<h3 id="Comparing_operands_of_different_types">Comparing operands of different types</h3>

<pre class="brush: js notranslate">console.log("3" === 3);           // false

console.log(true === 1);          // false

console.log(null === undefined);  // false</pre>

<h3 id="Comparing_objects">Comparing objects</h3>

<pre class="brush: js notranslate">const object1 = {
  name: "hello"
}

const object2 = {
  name: "hello"
}

console.log(object1 === object2);  // false
console.log(object1 === object1);  // true</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-equality-operators', 'Equality operators')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.strict_equality")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Equality">Equality operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Inequality">Inequality operator</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Strict_inequality">Strict inequality operator</a></li>
</ul>
